"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

module.exports = function () {
    function NavigationManager(entityType, getRouter) {
        _classCallCheck(this, NavigationManager);

        this.rootPath = entityType.name.toLowerCase();
        this.getRouter = getRouter;
    }

    _createClass(NavigationManager, [{
        key: "pathTo",
        value: function pathTo(entityOrId) {
            var id = entityOrId.id ? entityOrId.id : entityOrId;
            return "/" + this.rootPath + "/" + id;
        }
    }, {
        key: "navigate",
        value: function navigate(id) {
            this.getRouter().navigate(id ? this.pathTo(id) : this.mainPath);
        }
    }, {
        key: "navigateNew",
        value: function navigateNew() {
            this.getRouter().navigate(this.pathTo("new"));
        }
    }, {
        key: "mainPath",
        get: function get() {
            return "/" + this.rootPath;
        }
    }, {
        key: "newPath",
        get: function get() {
            return "/" + this.rootPath + "/new";
        }
    }, {
        key: "selectedPath",
        get: function get() {
            return "/" + this.rootPath + "/:selectedId";
        }
    }]);

    return NavigationManager;
}();